unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, RVScroll, RichView, RVEdit, RVStyle;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    RVStyle1: TRVStyle;
    RichViewEdit1: TRichViewEdit;
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    NewLine: boolean;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const TEXT_NORMAL = 0; 
      TEXT_HEADER1 = 1; 
      TEXT_HEADER2 = 2; 

      PARA_NORMAL = 0; 
      PARA_HEADER1 = 1; 
      PARA_HEADER2 = 2;

procedure InitStyles(RVStyle1: TRVStyle);
begin
  RVStyle1.TextStyles.Clear;
  // creating a style for normal text TEXT_NORMAL
  RVStyle1.TextStyles.Add;
  // creating a style for heading level 1 TEXT_HEADER1
  with RVStyle1.TextStyles.Add do begin
    Style := [fsBold, fsUnderline];
  end;
  // creating a style for heading level 2 TEXT_HEADER2
  with RVStyle1.TextStyles.Add do begin
    Style := [fsBold];
  end;
  RVStyle1.ParaStyles.Clear;
  // creating a style for normal paragraph PARA_NORMAL
  with RVStyle1.ParaStyles.Add do begin
    FirstIndent := 30;
  end;
  // creating a style for heading level 1 paragraph TEXT_HEADER1
  with RVStyle1.ParaStyles.Add do begin
    OutlineLevel := 1;
    FirstIndent := 5;
  end;
  // creating a style for heading level 2 paragraph TEXT_HEADER2
  with RVStyle1.ParaStyles.Add do begin
    OutlineLevel := 2;
    FirstIndent := 15;
  end;
end;

// Moving the caret to the beginnging of the current paragraph
procedure GoToParagraphStart(rve: TCustomRichViewEdit);
var i: Integer;
begin
  rve := rve.TopLevelEditor;
  for i := rve.CurItemNo downto 0 do
    if rve.IsParaStart(i) then begin
      rve.SetSelectionBounds(i, rve.GetOffsBeforeItem(i), i, rve.GetOffsBeforeItem(i));
      break;
    end;
end;

// Moving the caret to the end of document
procedure GoToEnd(rve: TCustomRichViewEdit);
var ItemNo, Offs: Integer;
begin
  ItemNo := rve.ItemCount-1;
  Offs := rve.GetOffsAfterItem(ItemNo);
  rve.SetSelectionBounds(ItemNo, Offs, ItemNo, Offs);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  RichViewEdit1.Clear;
  RichViewEdit1.Format;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  NewLine := CheckBox1.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Newline := false;
  ListBox1.ItemIndex := 0; ListBox2.ItemIndex := 0; Listbox3.ItemIndex := 0;
  InitStyles(RVStyle1);
end;


procedure TForm1.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if button = mbRight then begin
    GoToParagraphStart(RichViewEdit1);
    RichViewEdit1.InsertText(#13);
    SendMessage(RichViewEdit1.TopLevelEditor.Handle, WM_KEYDOWN, VK_UP, 0);
    RichViewEdit1.ApplyParaStyle(PARA_HEADER1);
    RichViewEdit1.ApplyTextStyle(TEXT_HEADER1);
    RichViewEdit1.InsertText(listbox1.Items.Strings[Listbox1.ItemIndex]);
    RichViewEdit1.SetFocus;
    //RichViewEdit1.ApplyTextStyle(TEXT_NORMAL);
  end;
end;

procedure TForm1.ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if button = mbright then begin
    GoToParagraphStart(RichViewEdit1);
    RichViewEdit1.InsertText(#13);
    SendMessage(RichViewEdit1.TopLevelEditor.Handle, WM_KEYDOWN, VK_UP, 0);
    RichViewEdit1.ApplyParaStyle(PARA_HEADER2);
    RichViewEdit1.ApplyTextStyle(TEXT_HEADER2);
    RichViewEdit1.InsertText(listbox2.Items.Strings[Listbox2.ItemIndex]);
    RichViewEdit1.SetFocus;
    //RichViewEdit1.ApplyTextStyle(TEXT_NORMAL);
  end;
end;

procedure TForm1.ListBox3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if button = mbright then begin
    GoToEnd(RichViewEdit1);
    if Newline then
      RichViewEdit1.InsertText(#13);
    RichViewEdit1.ApplyParaStyle(PARA_NORMAL);
    RichViewEdit1.ApplyTextStyle(TEXT_NORMAL);
    RichViewEdit1.InsertText(listbox3.Items.Strings[Listbox3.ItemIndex]);
    RichViewEdit1.SetFocus;
  end;
end;

end.

